%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Compare_Result = Compare_Chains(Chain_1, Chain_2)

Compare_Result = 1;

% Если цепочки совпадают
if (isequal(Chain_1, Chain_2))
    return;
end

% Если в цепочках не равное количество элементов
if (numel(Chain_1) ~= numel(Chain_2))
    Compare_Result = 0;
    return;
end

% Число элементов в цепочках
N_elements = numel(Chain_1);

% Поиск первого элемента первой цепочки во второй цепочке
[member_flag, location] = ismember(Chain_1(1), Chain_2);

% Если первый элемент первой цепочки не найден во второй цепочке
if (~member_flag)
    Compare_Result = 0;
    return;
end

% Формирование первого перестроения второй цепочки
Chain_2_Rebuild_1 = zeros(N_elements,1);

counter = 0;
tmp_location = location - 1;

while(1)
    
    tmp_location = tmp_location + 1;
    
    if (tmp_location > N_elements)
        tmp_location = 1;
    end
    
    counter = counter + 1;
    Chain_2_Rebuild_1(counter) = Chain_2(tmp_location);
    
    if (counter == N_elements)
        break;
    end
    
end

% Формирование второго перестроения второй цепочки
Chain_2_Rebuild_2 = zeros(N_elements,1);

counter = 0;
tmp_location = location + 1;

while(1)
    
    tmp_location = tmp_location - 1;
    
    if (tmp_location == 0)
        tmp_location = N_elements;
    end
    
    counter = counter + 1;
    Chain_2_Rebuild_2(counter) = Chain_2(tmp_location);
    
    if (counter == N_elements)
        break;
    end
    
end

% Сравнение первой цепочки с перестроениями второй цепочки
if ((~isequal(Chain_1, Chain_2_Rebuild_1)) && (~isequal(Chain_1, Chain_2_Rebuild_2)))
    Compare_Result = 0;
    return;
end
